CFPRIME INE32                                                           INE32       1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
      SUBROUTINE INE32                                                  INE32       3
CD                                                                      INE32       4
CD    TO PERFORM INITIALIZATION AND DATA CHECK FOR EXCITER TYPE 32.     INE32       5
CD                                                                      INE32       6
CD    THE DATA STRUCTURE AFTER THE INITIALIZATION IS GIVEN BELOW.       INE32       7
CD                                                                      INE32       8
CD   3.14 Exciter type 32                                               INE32       9
CD                                                                      INE32      10
CD     Exciter data                                                     INE32      11
CD                                                                      INE32      12
CD     IDDAT(JE+ 1)   = IVTN         : sensing bus number               INE32      13
CD     DDAT(JE+ 2)    = KA                                              INE32      14
CD     DDAT(JE+ 3)    = TA                                              INE32      15
CD     DDAT(JE+ 4)    = TC                                              INE32      16
CD     DDAT(JE+ 5)    = TB                                              INE32      17
CD     DDAT(JE+ 6)    = KF                                              INE32      18
CD     DDAT(JE+ 7)    = TF                                              INE32      19
CD     DDAT(JE+ 8)    = TF1                                             INE32      20
CD     DDAT(JE+ 9)    = TF2                                             INE32      21
CD     DDAT(JE+10)    = VRMAX                                           INE32      22
CD     DDAT(JE+11)    = VRMIN                                           INE32      23
CD     DDAT(JE+12)    = ETV                                             INE32      24
CD     DDAT(JE+13)    = KVF                                             INE32      25
CD     DDAT(JE+14)    = ETMIN                                           INE32      26
CD     DDAT(JE+15)    = KIFL                                            INE32      27
CD     DDAT(JE+16)    = IFLMT                                           INE32      28
CD     DDAT(JE+17)    = (reserved for future use)                       INE32      29
CD     DDAT(JE+18)    = TR                                              INE32      30
CD     DDAT(JE+19)    = RC                                              INE32      31
CD     DDAT(JE+20)    = XC                                              INE32      32
CD     DDAT(JE+21)    = KETL                                            INE32      33
CD     DDAT(JE+22)    = TL1                                             INE32      34
CD     DDAT(JE+23)    = TL2                                             INE32      35
CD     DDAT(JE+24)    = ETLMT                                           INE32      36
CD     DDAT(JE+25)    = LIMOUT                                          INE32      37
CD     DDAT(JE+26)    = VIMAX                                           INE32      38
CD     DDAT(JE+27)    = VIMIN                                           INE32      39
CD     DDAT(JE+28)    = VTMAX                                           INE32      40
CD     DDAT(JE+29)    = VTMIN                                           INE32      41
CD     DDAT(JE+30)    = VOMX                                            INE32      42
CD     DDAT(JE+31)    = VOMN                                            INE32      43
CD     DDAT(JE+32)    = ACON                                            INE32      44
CD     DDAT(JE+33)    = BCON                                            INE32      45
CD     DDAT(JE+34)    = VSMAX                                           INE32      46
CD     DDAT(JE+35)    = VSMIN                                           INE32      47
CD                                                                      INE32      48
CD     Exciter states                                                   INE32      49
CD                                                                      INE32      50
CD     XSTATE(JES+1)  = TR block     : compulsory                       INE32      51
CD     XSTATE(JES+2)  = TL2 block    : compulsory                       INE32      52
CD     XSTATE(JES+3)  = TF block     : optional                         INE32      53
CD     XSTATE(JES+4)  = TF2 block    : optional                         INE32      54
CD     XSTATE(JES+5)  = TB block     : optional                         INE32      55
CD     XSTATE(JES+6)  = TA block     : compulsory                       INE32      56
CD                                                                      INE32      57
CD     Exciter Y-variables                                              INE32      58
CD                                                                      INE32      59
CD     VREG(JYE+1)    = VC (input to the TR block)                      INE32      60
CD     VREF(JYE+2)    = reference value                                 INE32      61
CD     VRFIN(JYE+3)   = output of TA block (exciter EFD)                INE32      62
CD     YVAR(JYE+4)    = output of continuous path in terminal volt      INE32      63
CD                      limiter                                         INE32      64
CD     YVAR(JYE+5)    = output of discontinuous path in terminal volt   INE32      65
CD                      limiter                                         INE32      66
CD                                                                      INE32      67
      INCLUDE 'PARX.INS'                                                INE32      68
      INCLUDE 'CNMDAT.INS'                                              INE32      69
      INCLUDE 'CNMSTA.INS'                                              INE32      70
      INCLUDE 'CNXSTA.INS'                                              INE32      71
      INCLUDE 'CNB8.INS'                                                INE32      72
      INCLUDE 'CNEXC.INS'                                               INE32      73
      INCLUDE 'CNMYVA.INS'                                              INE32      74
      INCLUDE 'CNUNIT.INS'                                              INE32      75
      INCLUDE 'CNYVAR.INS'                                              INE32      76
      INCLUDE 'CNSTN.INS'                                               INE32      77
      INCLUDE 'CNB1.INS'                                                INE32      78
      INCLUDE 'CNB4.INS'                                                INE32      79
      INCLUDE 'CNIMPR.INS'                                              INE32      80
      INCLUDE 'CNMSG.INS'                                               INE32      81
      INCLUDE 'CNXDOT.INS'                                              INE32      82
C                                                                       INE32      83
      DATA BIG/99.9/                                                    INE32      84
C                                                                       INE32      85
C      IEX = 32 (DISCONTINUOUS EXCITER)                                 INE32      86
C                                                                       INE32      87
C  INPUT TIME CONSTANTS CHECK AND RESET                                 INE32      88
C                                                                       INE32      89
      IF(DDAT(JE+3).LT.TMIN.AND.IDDAT(JE+3).NE.0)THEN                   INE32      90
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INE32      91
     *                     ,NDGC(N)                                     INE32      92
         WRITE(MSG(2),9030) 'TA',DDAT(JE+3),TMIN                        INE32      93
         IF(MTFLAG.EQ.0) THEN                                           INE32      94
            CALL PRTMSG(2)                                              INE32      95
         ELSE                                                           INE32      96
         WRITE(MSG(3),9040) 'TA',0.0                                    INE32      97
         CALL PRTMSG(3)                                                 INE32      98
         DDAT(JE+3)=0.0                                                 INE32      99
         ENDIF                                                          INE32     100
      ENDIF                                                             INE32     101
C                                                                       INE32     102
      IF(DDAT(JE+5).LT.TMIN.AND.IDDAT(JE+5).NE.0)THEN                   INE32     103
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INE32     104
     *                     ,NDGC(N)                                     INE32     105
         WRITE(MSG(2),9030) 'TB',DDAT(JE+5),TMIN                        INE32     106
         IF(MTFLAG.EQ.0) THEN                                           INE32     107
            CALL PRTMSG(2)                                              INE32     108
         ELSE                                                           INE32     109
         WRITE(MSG(3),9040) 'TB',0.0                                    INE32     110
         CALL PRTMSG(3)                                                 INE32     111
         DDAT(JE+5)=0.0                                                 INE32     112
         ENDIF                                                          INE32     113
      ENDIF                                                             INE32     114
C                                                                       INE32     115
      IF(DDAT(JE+7).LT.TMIN.AND.IDDAT(JE+7).NE.0)THEN                   INE32     116
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INE32     117
     *                     ,NDGC(N)                                     INE32     118
         WRITE(MSG(2),9030) 'TF',DDAT(JE+7),TMIN                        INE32     119
         IF(MTFLAG.EQ.0) THEN                                           INE32     120
            CALL PRTMSG(2)                                              INE32     121
         ELSE                                                           INE32     122
         WRITE(MSG(3),9040) 'TF',0.0                                    INE32     123
         CALL PRTMSG(3)                                                 INE32     124
         DDAT(JE+7)=0.0                                                 INE32     125
         ENDIF                                                          INE32     126
      ENDIF                                                             INE32     127
C                                                                       INE32     128
      IF(DDAT(JE+9).LT.TMIN.AND.IDDAT(JE+9).NE.0)THEN                   INE32     129
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INE32     130
     *                     ,NDGC(N)                                     INE32     131
         WRITE(MSG(2),9030) 'TF2',DDAT(JE+9),TMIN                       INE32     132
         IF(MTFLAG.EQ.0) THEN                                           INE32     133
            CALL PRTMSG(2)                                              INE32     134
         ELSE                                                           INE32     135
         WRITE(MSG(3),9040) 'TF2',0.0                                   INE32     136
         CALL PRTMSG(3)                                                 INE32     137
         DDAT(JE+9)=0.0                                                 INE32     138
         ENDIF                                                          INE32     139
      ENDIF                                                             INE32     140
C                                                                       INE32     141
      IF(DDAT(JE+18).LT.TMIN.AND.IDDAT(JE+18).NE.0)THEN                 INE32     142
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INE32     143
     *                     ,NDGC(N)                                     INE32     144
         WRITE(MSG(2),9030) 'TR',DDAT(JE+18),TMIN                       INE32     145
         IF(MTFLAG.EQ.0) THEN                                           INE32     146
            CALL PRTMSG(2)                                              INE32     147
         ELSE                                                           INE32     148
         WRITE(MSG(3),9040) 'TR',0.0                                    INE32     149
         CALL PRTMSG(3)                                                 INE32     150
         DDAT(JE+18)=0.0                                                INE32     151
         ENDIF                                                          INE32     152
      ENDIF                                                             INE32     153
C                                                                       INE32     154
      IF(DDAT(JE+23).LT.TMIN.AND.IDDAT(JE+23).NE.0)THEN                 INE32     155
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INE32     156
     *                     ,NDGC(N)                                     INE32     157
         WRITE(MSG(2),9030) 'TL2',DDAT(JE+23),TMIN                      INE32     158
         IF(MTFLAG.EQ.0) THEN                                           INE32     159
            CALL PRTMSG(2)                                              INE32     160
         ELSE                                                           INE32     161
         WRITE(MSG(3),9040) 'TL2',0.0                                   INE32     162
         CALL PRTMSG(3)                                                 INE32     163
         DDAT(JE+23)=0.0                                                INE32     164
         ENDIF                                                          INE32     165
      ENDIF                                                             INE32     166
C                                                                       INE32     167
C   DATA PREPARATION AND INPUT DATA PRINTOUT                            INE32     168
C                                                                       INE32     169
      IF (IDDAT(JE+34).EQ.0.AND.IDDAT(JE+35).EQ.0) THEN                 INE32     170
         DDAT(JE+34)=BIG                                                INE32     171
         DDAT(JE+35)=-BIG                                               INE32     172
      ENDIF                                                             INE32     173
      IF (IDDAT(JE+10).EQ.0.AND.IDDAT(JE+11).EQ.0) THEN                 INE32     174
         DDAT(JE+10)=BIG                                                INE32     175
         DDAT(JE+11)=-BIG                                               INE32     176
      ENDIF                                                             INE32     177
      IF (IDDAT(JE+26).EQ.0.AND.IDDAT(JE+27).EQ.0) THEN                 INE32     178
         DDAT(JE+26)=DDAT(JE+34)                                        INE32     179
         DDAT(JE+27)=DDAT(JE+35)                                        INE32     180
      ENDIF                                                             INE32     181
      IF (IDDAT(JE+28).EQ.0.AND.IDDAT(JE+29).EQ.0) THEN                 INE32     182
         DDAT(JE+28)=BIG                                                INE32     183
         DDAT(JE+29)=-BIG                                               INE32     184
      ENDIF                                                             INE32     185
      IF (IDDAT(JE+30).EQ.0.AND.IDDAT(JE+31).EQ.0) THEN                 INE32     186
         DDAT(JE+30)=BIG                                                INE32     187
         DDAT(JE+31)=-BIG                                               INE32     188
      ENDIF                                                             INE32     189
      IDDAT(JE+36)=-1                                                   INE32     190
C                                                                       INE32     191
C     DDAT(JE+42) THROUGH DDAT(JE+45) ARE USED TO STORE THE             INE32     192
C     SUBSCRIPTS OF OPTIONAL BLOCKS. IF ZERO, THE CORRESPONDING         INE32     193
C     BLOCK IS NOT PRESENT.                                             INE32     194
C                                                                       INE32     195
      IDDAT(JE+42)=0                                                    INE32     196
      IDDAT(JE+43)=0                                                    INE32     197
      IDDAT(JE+44)=0                                                    INE32     198
      IDDAT(JE+45)=0                                                    INE32     199
C                                                                       INE32     200
      IF (IDDAT(JE+6).EQ.0.OR.IDDAT(JE+7).EQ.0) THEN                    INE32     201
         DDAT(JE+8)=0.0                                                 INE32     202
         DDAT(JE+9)=0.0                                                 INE32     203
      ENDIF                                                             INE32     204
C                                                                       INE32     205
      KSTATE=1                                                          INE32     206
      VE=EFDN/DDAT(JE+2)                                                INE32     207
C                                                                       INE32     208
C  EXCITER CELING REGULATOR                                             INE32     209
C                                                                       INE32     210
      IF (IDDAT(JE+12).NE.0)THEN                                        INE32     211
      ETR=ET/DDAT(JE+12)                                                INE32     212
      ELSE                                                              INE32     213
      ETR=1.0                                                           INE32     214
      ENDIF                                                             INE32     215
C                                                                       INE32     216
      EFCF=DDAT(JE+13)*EFDN                                             INE32     217
      EFMX=DDAT(JE+10)*ETR-EFCF                                         INE32     218
      EFMN=DDAT(JE+11)*ETR+EFCF                                         INE32     219
C                                                                       INE32     220
C  TERMINAL VOLTAGE LIMITER BLOCK                                       INE32     221
C                                                                       INE32     222
      IF(ET.GT.DDAT(JE+24))THEN                                         INE32     223
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INE32     224
     *                     ,NDGC(N)                                     INE32     225
         WRITE(MSG(2),9010)                                             INE32     226
         WRITE(MSG(3),9020) ET,DDAT(JE+24)                              INE32     227
         CALL PRTMSG(3)                                                 INE32     228
      ENDIF                                                             INE32     229
      IF(ET.GT.DDAT(JE+28))THEN                                         INE32     230
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INE32     231
     *                     ,NDGC(N)                                     INE32     232
         WRITE(MSG(2),9100)                                             INE32     233
         WRITE(MSG(3),9110) ET,DDAT(JE+28)                              INE32     234
         CALL PRTMSG(3)                                                 INE32     235
      ENDIF                                                             INE32     236
C                                                                       INE32     237
C  V2 PRIME                                                             INE32     238
C                                                                       INE32     239
      KSTATE=KSTATE+1                                                   INE32     240
      V2=(ET-DDAT(JE+24))*DDAT(JE+21)                                   INE32     241
      IF (V2.LT.DDAT(JE+31)) V2=DDAT(JE+31)                             INE32     242
      XSTATE(JSTATE+KSTATE)=V2                                          INE32     243
      IF(V2.GT.DDAT(JE+30))THEN                                         INE32     244
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INE32     245
     *                     ,NDGC(N)                                     INE32     246
         WRITE(MSG(2),9200)                                             INE32     247
         WRITE(MSG(3),9210) V2,DDAT(JE+30),DDAT(JE+31)                  INE32     248
         CALL PRTMSG(3)                                                 INE32     249
      ENDIF                                                             INE32     250
      YVAR(JYE+4)=V2                                                    INE32     251
      YVAR(JYE+5)=0.0                                                   INE32     252
C                                                                       INE32     253
C  V5 PRIME -- OPTIONAL                                                 INE32     254
C                                                                       INE32     255
       IF (IDDAT(JE+7).NE.0.AND.IDDAT(JE+6).NE.0)THEN                   INE32     256
          KSTATE=KSTATE+1                                               INE32     257
          XSTATE(JSTATE+KSTATE)=EFDN                                    INE32     258
          IDDAT(JE+42)=JSTATE+KSTATE-NSTATE                             INE32     259
C                                                                       INE32     260
C  V5 PRIME PRIME -- OPTIONAL                                           INE32     261
C                                                                       INE32     262
          IF (IDDAT(JE+9).NE.0)THEN                                     INE32     263
             KSTATE=KSTATE+1                                            INE32     264
             XSTATE(JSTATE+KSTATE)=0.0                                  INE32     265
             IDDAT(JE+43)=JSTATE+KSTATE-NSTATE                          INE32     266
          ENDIF                                                         INE32     267
       ENDIF                                                            INE32     268
C                                                                       INE32     269
C  V3 PRIME -- OPTIONAL                                                 INE32     270
C                                                                       INE32     271
       IF (IDDAT(JE+5).NE.0)THEN                                        INE32     272
       KSTATE=KSTATE+1                                                  INE32     273
       XSTATE(JSTATE+KSTATE)=VE                                         INE32     274
       IDDAT(JE+44)=JSTATE+KSTATE-NSTATE                                INE32     275
       ENDIF                                                            INE32     276
C                                                                       INE32     277
C  V4                                                                   INE32     278
C                                                                       INE32     279
       KSTATE=KSTATE+1                                                  INE32     280
       XSTATE(JSTATE+KSTATE)=EFDN                                       INE32     281
C                                                                       INE32     282
       XDFACT(JSTATE+KSTATE)=DDAT(JE+2)                                 INE32     283
C                                                                       INE32     284
       VREF(JYE+2)=XSTATE(JSTATE+1)+EFDN/DDAT(JE+2)                     INE32     285
       IDDAT(JE+45)=JSTATE+KSTATE-NSTATE                                INE32     286
C                                                                       INE32     287
C      IF TA NON-ZERO, IDDAT(JE+41) = 1                                 INE32     288
C      IF TA = 0.0, IDDAT(JE+41) = 2                                    INE32     289
C                                                                       INE32     290
C      THIS FLAG IS USED IN IMPLICIT METHOD.                            INE32     291
C                                                                       INE32     292
       IF (IDDAT(JE+3).EQ.0) THEN                                       INE32     293
          IDDAT(JE+41)=2                                                INE32     294
       ELSE                                                             INE32     295
          IDDAT(JE+41)=1                                                INE32     296
       END IF                                                           INE32     297
C                                                                       INE32     298
      VRFIN(JYE+3)=EFDN                                                 INE32     299
      JSTATE=JSTATE+KSTATE                                              INE32     300
      JY=JY+5                                                           INE32     301
C                                                                       INE32     302
C     DETERMINE THE LARGEST TIME STEP PERMITTED                         INE32     303
C                                                                       INE32     304
      TMAX=99.0                                                         INE32     305
      IF (IDDAT(JE+6).NE.0.AND.IDDAT(JE+7).NE.0) THEN                   INE32     306
         IDDAT(JE+39)=1                                                 INE32     307
         TMAX=DDAT(JE+7)/(DDAT(JE+2)*DDAT(JE+6))                        INE32     308
         IF (IDDAT(JE+9).NE.0) THEN                                     INE32     309
            TMAX=TMAX*DDAT(JE+9)                                        INE32     310
            IF (IDDAT(JE+8).NE.0) TMAX=TMAX/(1.0+DDAT(JE+8))            INE32     311
         END IF                                                         INE32     312
         IF (IDDAT(JE+5).NE.0) THEN                                     INE32     313
            TMAX=TMAX*DDAT(JE+5)                                        INE32     314
            IF (IDDAT(JE+4).NE.0) TMAX=TMAX/(1.0+DDAT(JE+4))            INE32     315
         END IF                                                         INE32     316
         IF (IDDAT(JE+3).NE.0) TMAX=TMAX*DDAT(JE+3)                     INE32     317
         IF (TMAX.LT.DTMIN) TMAX=DTMIN                                  INE32     318
      ELSE                                                              INE32     319
         IDDAT(JE+39)=0                                                 INE32     320
      END IF                                                            INE32     321
      DDAT(JE+40)=TMAX                                                  INE32     322
C                                                                       INE32     323
C==                                                                     INE32     324
C      WRITE(IUD,711) JYE,JY,(YVAR(IK),IK=1,20)                         INE32     325
C  711 FORMAT(1X,'DB-INE32:JYE,JY,YVAR1-20 ',2I5,/,(1X,10G12.5))        INE32     326
C==                                                                     INE32     327
C                                                                       INE32     328
C     IDDAT(JE+46) = 0 FIELD CURRENT LIMITER NOT TRIGGERED              INE32     329
C                  = 1 FIELD CURRENT LIMITER TRIGGERD                   INE32     330
C                                                                       INE32     331
      IDDAT(JE+46)=0                                                    INE32     332
      IF(IDDAT(JE+15).NE.0)THEN                                         INE32     333
         IF (EFDN.GT.DDAT(JE+16))THEN                                   INE32     334
            IDDAT(JE+46)=1                                              INE32     335
            WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)    INE32     336
     *                        ,NDGC(N)                                  INE32     337
            WRITE(MSG(2),9300)                                          INE32     338
            WRITE(MSG(3),9310) EFDN,DDAT(JE+16)                         INE32     339
            CALL PRTMSG(3)                                              INE32     340
         ENDIF                                                          INE32     341
      ENDIF                                                             INE32     342
      IF (EFDN.GT.EFMX.OR.EFDN.LT.EFMN)THEN                             INE32     343
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INE32     344
     *                     ,NDGC(N)                                     INE32     345
         WRITE(MSG(2),9400)                                             INE32     346
         WRITE(MSG(3),9410) EFDN,EFMX,EFMN                              INE32     347
         CALL PRTMSG(3)                                                 INE32     348
      ENDIF                                                             INE32     349
      IF (VE.GT.DDAT(JE+26).OR.VE.LT.DDAT(JE+27))THEN                   INE32     350
         WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)       INE32     351
     *                     ,NDGC(N)                                     INE32     352
         WRITE(MSG(2),9500)                                             INE32     353
         WRITE(MSG(3),9510) VE,DDAT(JE+26),DDAT(JE+27)                  INE32     354
         CALL PRTMSG(3)                                                 INE32     355
      ENDIF                                                             INE32     356
C                                                                       INE32     357
      RETURN                                                            INE32     358
 9000 FORMAT(' *** WARNING GENERATOR AT BUS: ',I5,' STATION: ',3A4      INE32     359
     *,' GID:',A4)                                                      INE32     360
 9010 FORMAT(5X,'TYPE 32 EXCITER  ET VIOLATES UPPER LIMIT')             INE32     361
 9020 FORMAT(5X,'ET = ',G12.5,' ETLMT = ',G12.5)                        INE32     362
 9030 FORMAT(5X,'TYPE 32 EXCITER ',A,'=',F8.6                           INE32     363
     *,' IS BELOW THE LIMIT VALUE OF ',F4.2)                            INE32     364
 9040 FORMAT(5X,A,' HAS BEEN SET TO ',F4.2)                             INE32     365
 9100 FORMAT(5X,'TYPE 32 EXCITER  ET VIOLATES UPPER LIMIT:')            INE32     366
 9110 FORMAT(5X,'ET = ',G12.5,' ETMAX = ',G12.5)                        INE32     367
 9200 FORMAT(5X,'TYPE 32 EXCITER  STATE 2 (V2) VIOLATES LIMITS:')       INE32     368
 9210 FORMAT(5X,'V2 = ',G12.5,' VOMX = ',G12.5,' GOMN = ',G12.5)        INE32     369
 9300 FORMAT(5X,'TYPE 32 EXCITER  IFDN VIOLATES UPPER LIMIT:')          INE32     370
 9310 FORMAT(5X,'IFDN = ',G12.5,' IFLMT = ',G12.5)                      INE32     371
 9400 FORMAT(5X,'TYPE 32 EXCITER  EFDN VIOLATES LIMITS:')               INE32     372
 9410 FORMAT(5X,'EFDN = ',G12.5,' EFMX = ',G12.5,' EFMN = ',G12.5)      INE32     373
 9500 FORMAT(5X,'TYPE 32 EXCITER  VE VIOLATES LIMITS:')                 INE32     374
 9510 FORMAT(5X,'VE = ',G12.5,' VIMAX = ',G12.5,' VIMIN = ',G12.5)      INE32     375
C                                                                       INE32     376
      END                                                               INE32     377
